=== debian/changelog ===
blis (0.5.1-11) unstable; urgency=medium

  * Add version script for libblas.so.3 to export only {C,}BLAS ABI.
  * Add test-name feature to Autopkgtest control file.
    And remove unnecessary test cases.
  * Update lintian overrides.
  * Add upstream/metadata file.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 06 Feb 2019 08:43:40 +0000

blis (0.5.1-10) unstable; urgency=medium

  * Correct BLIS64 alternative name: libblis64.so.@SOVER@-@DEB_HOST_MULTIARCH@

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 05 Feb 2019 03:36:17 +0000

blis (0.5.1-9) unstable; urgency=medium

  * Add Restrictions: needs-root to maintainer-script autopkgtest cases.
  * Rename libblis{,64-}2-symbols.* to libblis{,64-}2-XXX.symbols.*
  * Rewrite the shell loop for creating symlinks for symbols files.
  * Guard test targets with nocheck detector in rules.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 05 Feb 2019 02:35:23 +0000

blis (0.5.1-8) unstable; urgency=medium

  * Make all BLIS variants co-installable. (Closes: #919272)
    + Move all shlibs and headers to private directories.
    + Rewrite libblis2-openmp.{postinst,prerm} into common templates.
    + Rewrite libblis64-2-openmp.{postinst,prerm} into common templates.
    + Rewrite libblis-openmp-dev.{postinst,prerm} into common templates.
    + Rewrite libblis64-openmp-dev.{postinst,prerm} into common templates.
    + Add libblis{,64}.a as slave links for libblis.so.
    + Generate maintainer scripts from templates.
    - Remove all Conflicts relationship between BLIS variants.
  * Virtual Package / Provides updates:
    - libblas{,64}.so   is no longer provided by libblis{,64}-dev.
    - libblas{,64}.so.3 is no longer provided by libblis{,64-}2.
    + libblis-{...}-dev   Provides libblis.so,     libblas.so
    + libblis2-{...}      Provides libblis.so.2,   libblas.so.3
    + libblis64-{...}-dev Provides libblis64.so,   libblas64.so
    + libblis64-2-{...}   Provides libblis64.so.2, libblas64.so.3
  * Autopkgtest Updates:
    + Add test cases for maintainer scripts.
    + Run libblas-test against all BLIS variants.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 04 Feb 2019 06:14:56 +0000

blis (0.5.1-7) unstable; urgency=medium

  * Modify upstream header to amend kFreeBSD detection.
  * Patch upstream Makefile to build separate libblas.so* .
  * Install separate libblas into blis{,64} subdirs, (Closes: #919273)
    where its SONAME is "libblas.so.3".
  * Change libblas.so* provider from libblis.so* to blis*/libblas.so*.
  * Override dh_dwz to append --no-dwz-multifile option.
  * Don't track symbols list for private shared objects.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 27 Jan 2019 06:18:53 +0000

blis (0.5.1-6) unstable; urgency=medium

  * Cherry-pick upstream commit to fix configure on kfreebsd.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 22 Jan 2019 14:35:38 +0000

blis (0.5.1-5) unstable; urgency=medium

  * Use generic kernel for armel,armhf architectures. (Closes: #919710)

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 19 Jan 2019 02:39:44 +0000

blis (0.5.1-4) unstable; urgency=medium

  * Fix the problematic patch for Hurd.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 17 Jan 2019 05:02:27 +0000

blis (0.5.1-3) unstable; urgency=medium

  * Run fast version of test on all architectures.
  * Add patch to port BLIS to GNU Hurd OS.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 17 Jan 2019 04:43:00 +0000

blis (0.5.1-2) unstable; urgency=medium

  * Bump debhelper compat to 12.
  * Bump Standards-Version to 4.3.0 (no change).
  * Let libblis-dev (instead of libblis-*-dev) provide libblas.so.
  * Change (arm32,arm64) targets into (cortexa15,cortexa57).
  * Refresh symbols control file for arm64 and armhf.
  * Autopkgtest Depends on build-essential instead of merely gcc.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 16 Jan 2019 12:20:46 +0000

blis (0.5.1-1) unstable; urgency=medium

  * New upstream version 0.5.1
  * Add version condition to dependencies of libblis-1 and libblis64-1.
  * Collect symbol patches for various architectures from buildd.
  * Bump SOVERSION from 1 to 2, and SONAME to libblis.so.2
  * Overhaul d/rules for the SOVERSION bump and auto symlink creation.
    - Remove all symlinks under debian directory.
  * Remove all patches, problems fixed upstream.
  * Export a proper PYTHON variable for upstream build system.
  * Update dependency-template in symbols control file, stripping the
    threadding identifier postfix.
  * Override symbols-declares-dependency-on-other-package on shlib packages.
    The dependency template should really be libblis2 (meta) or
    libblis64-2 (meta) instead of a specific backend used during build.
  * Add autopkgtest control file with 6 test cases.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 03 Jan 2019 11:36:29 +0000

blis (0.5.0-1) unstable; urgency=low

  * Initial upload based on Nico Schlömer's work. (Closes: #909457)

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 18 Dec 2018 03:13:26 +0000
