=== debian/tests/control ===
# ---------------------- functionality tests ----------------------------------

Test-Command: LD_LIBRARY_PATH=/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH)/blis-openmp sh /usr/share/doc/libblas-test/examples/run_blas_tests.sh
Restrictions: allow-stderr
Depends: libblas-test, libblis-openmp-dev,
Features: test-name=blis_blas_test_openmp

Test-Command: LD_LIBRARY_PATH=/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH)/blis-pthread sh /usr/share/doc/libblas-test/examples/run_blas_tests.sh
Restrictions: allow-stderr
Depends: libblas-test, libblis-pthread-dev,
Features: test-name=blis_blas_test_pthread

Test-Command: LD_LIBRARY_PATH=/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH)/blis-serial sh /usr/share/doc/libblas-test/examples/run_blas_tests.sh
Restrictions: allow-stderr
Depends: libblas-test, libblis-serial-dev,
Features: test-name=blis_blas_test_serial

Test-Command: sed -i -e 's@blis.h@blis64.h@' test/test_gemm.c;
 gcc test/test_gemm.c -DBLAS=\"blis\" -lblis64 -lm -o tester; ./tester
Restrictions: allow-stderr
Depends: build-essential, libblis64-dev, libblis64-openmp-dev,

Test-Command: sed -i -e 's@blis.h@blis64.h@' test/test_gemm.c;
 gcc test/test_gemm.c -DBLAS=\"blis\" -lblis64 -lm -o tester; ./tester
Restrictions: allow-stderr
Depends: build-essential, libblis64-dev, libblis64-pthread-dev,

Test-Command: sed -i -e 's@blis.h@blis64.h@' test/test_gemm.c;
 gcc test/test_gemm.c -DBLAS=\"blis\" -lblis64 -lm -o tester; ./tester
Restrictions: allow-stderr
Depends: build-essential, libblis64-dev, libblis64-serial-dev,

# ---------------- installation / maintainer script tests ---------------------

Test-Command: apt-get purge libblis-dev libblis-openmp-dev libblis-pthread-dev libblis-serial-dev -y
Restrictions: needs-root,
Depends: libblis-dev, libblis-openmp-dev, libblis-pthread-dev, libblis-serial-dev,
Features: test-name=blis_maintscript

Test-Command: apt-get purge libblis64-dev libblis64-openmp-dev libblis64-pthread-dev libblis64-serial-dev -y
Restrictions: needs-root,
Depends: libblis64-dev, libblis64-openmp-dev, libblis64-pthread-dev, libblis64-serial-dev,
Features: test-name=blis64_maintscript
